﻿;
; AutoHotkey Version: 1.x
; Language:       English
; Platform:       Win9x/NT
; Author:         Jack Dunning
;
; Script Function:
;	This version of RecipeTree reads the CSV file RecipeTree.csv
;       and constructs the GUI window and save the data again
;

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

Gui, default
Gui +AlwaysOnTop +Resize

Gui, Add, TreeView, vMyTreeView gMyTreeView h400 AltSubmit -ReadOnly
Gui, Add, Edit, ys vMyEdit gMyEdit w300 h400
Gui, Add, Button, xm gSave, Save

 Loop, Read, RecipeTree.csv
  {
     Loop, Parse, A_LoopReadLine , CSV
       {
          RowData%A_Index% := A_LoopField
       }
          StringReplace, RowData4, RowData4,|,`n, All

       If RowData2 = 0
        {
          RecipeID := TV_Add(RowData3)
          %RowData1% := RecipeID
          %RecipeID% := RowData1
          RowText := RecipeID . "text"
          %RowText% := RowData4
        }
       Else
        {
          Ingredient := RowData1 . RowData2
          IngredientID := TV_Add(RowData3, %Rowdata1%)
          %IngredientID% := Ingredient
          RowText := IngredientID . "text"
          %RowText% := RowData4
        }
  }

Gui, Show  ; Show the window and its TreeView.
return

MyEdit:
 Gui, Submit, NoHide
 Text := TV_GetSelection() . "text"
 %Text% := MyEdit
Return

MyTreeView:
 TV_GetText(TreeText, TV_GetSelection())
 Unit := TV_GetSelection()
 Text := TV_GetSelection() . "text"
 GuiControl, , MyEdit, % %Text%
Return

Save:
  UpdateFile()
Return


GuiSize:  ; Expand or shrink the TreeView in response to the user's resizing of the window.
if A_EventInfo = 1  ; The window has been minimized.  No action needed.
    return
; Otherwise, the window has been resized or maximized. Resize the ListView to match.
GuiControl, Move, MyTreeView, % " H" . (A_GuiHeight - 40) ;"W" . (A_GuiWidth - 20) . 
GuiControl, Move, MyEdit, % "W" . (A_GuiWidth - 275) . " H" . (A_GuiHeight - 40)  
GuiControl, Move, Button1, % "y" . (A_GuiHeight - 30) 
Return

GuiClose:  ; Exit the script when the user closes the TreeView's GUI window.
ExitApp
Return

UpdateFile()
  {
    FileDelete, RecipeTree.csv
    R = 1
    C = 1
    ItemID = 0  ; Causes the loop's first iteration to start the search at the top of the tree.
    Loop
      {
       ItemID := TV_GetNext(ItemID, "Full")  
       if not ItemID  ; No more items in tree.
           break
       TV_GetText(ItemText, ItemID)
       If TV_GetParent(ItemID) = 0
         {
          ParentCode := "R" . R
          ChildCode := 0
          R += 1
          C = 1
         }
       Else
         {
          ChildCode := "C" . C
          C += 1
         }
       TextValue := %ItemID%text
              StringReplace, TextValue, TextValue,", "", All
              StringReplace, TextValue, TextValue,`n,|, All
       FileAppend, "%ParentCode%"`,"%ChildCode%"`,"%ItemText%"`,"%TextValue%" `n, RecipeTree.csv
     }         
   }
